using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
namespace Theremino_HAL
{
	static class Module_FillBars
	{

		// =======================================================================================
        //  Display Data Scope
		// =======================================================================================

        static Int32 static_DisplayCounterscope_n = 0;
        static float static_DisplayCounterscope_oldy2 = 1000000;
        static float static_DisplayCounterscope_oldy1 = 1000000;

		public static void DisplayDataScope(PictureBox pbox, Single count1, Single count2, Int32 speed)
		{
			// ------------------------------------------------ remove possible errors
			if (count1 < -1000000) count1 = 0; 
			if (count2 < -1000000) count2 = 0; 
			if (count1 > 1000000) count1 = 0; 
			if (count2 > 1000000) count2 = 0; 
			// ------------------------------------------------ using a bitmap for best performance
			if (pbox.Image == null) 
            {
                Module_ImageFilters.InitPictureboxImage(pbox);
			}
			// ------------------------------------------------ using "Graphics.FromImage" for best performance
			Graphics g = Graphics.FromImage(pbox.Image);
            float px = pbox.ClientSize.Width - 1;
			//
			
			// ------------------------------------------------ draw the scale
            Single d = pbox.ClientSize.Height / 10.1F;
            Single y = 1;
            Pen p1 = new Pen(Color.FromArgb(140, 140, 140));
            Pen p2 = new Pen(Color.FromArgb(210, 210, 210));
			for (Int32 i = 0; i <= 10; i ++) 
            {
				g.DrawLine(p1, px, y, px + 1, y);
                y += d / 2;
                g.DrawLine(p2, px, y, px + 1, y);
                y += d / 2;
			}
            // ------------------------------------------------ draw indicators
            p1 = new Pen(Color.DarkBlue, 2);
            p2 = new Pen(Color.DarkRed, 2);
            float py1 = 2 * count1 + pbox.ClientSize.Height / 2f;
            float py2 = 2 * count2 + pbox.ClientSize.Height / 2f;
            if (Single.IsNaN(static_DisplayCounterscope_oldy1) | Math.Abs(static_DisplayCounterscope_oldy1 - py1) > 1000) static_DisplayCounterscope_oldy1 = py1;
            if (Single.IsNaN(static_DisplayCounterscope_oldy2) | Math.Abs(static_DisplayCounterscope_oldy2 - py2) > 1000) static_DisplayCounterscope_oldy2 = py2; 
            g.DrawLine(p1, px - 1, static_DisplayCounterscope_oldy1, px, py1);
            g.DrawLine(p2, px - 1, static_DisplayCounterscope_oldy2, px, py2);
            static_DisplayCounterscope_oldy1 = py1;
            static_DisplayCounterscope_oldy2 = py2;
            // ------------------------------------------------ scroll
            static_DisplayCounterscope_n += speed;
            if (static_DisplayCounterscope_n > 100)
            {
                static_DisplayCounterscope_n -= 100;
                // ---------------------------------------------------- original
                //Module_ImageFilters.PictureScrollInPlace(pbox, -1, 0, 0);
                // ---------------------------------------------------- fast
                g.CompositingQuality = CompositingQuality.HighSpeed;
                g.SmoothingMode = SmoothingMode.HighSpeed;
                g.InterpolationMode = InterpolationMode.Low;
                //g.DrawImage(pbox.Image, -1, 0); //<-- NOT WORKING ON XP
                g.DrawImage((Image)pbox.Image.Clone(), -1, 0);
                g.DrawLine(Pens.AliceBlue, px, 0, px, pbox.ClientSize.Height);
                // -----------------------------------------------------
                pbox.Invalidate();
            }
		}


		// =======================================================================================
		//  FILL PICTURE BOX - WITH SINGLE COLOR
		// =======================================================================================
		public static void FillPictureBox(PictureBox pbox, 
                                            double value, 
                                            Color c1, 
                                            Color c2)
		{
			// ------------------------------------------------------- using a bitmap for best performance
			if (pbox.Image == null) 
            {
                Module_ImageFilters.InitPictureboxImage(pbox);
			}
			// -------------------------------------------------------
			if (double.IsNaN(value)) value = 0; 
			if (value < 0) value = 0; 
			if (value > 1) value = 1;
            Int32 v = (int)(value * pbox.ClientSize.Width);
			// ------------------------------------------------------- using "Graphics.FromImage" for best performance
			Graphics g = Graphics.FromImage(pbox.Image);
			g.FillRectangle(new SolidBrush(c1), 0, 0, v, pbox.ClientSize.Height);
			g.FillRectangle(new SolidBrush(c2), v, 0, pbox.ClientSize.Width - v, pbox.ClientSize.Height);
			//
			// ------------------------------------------------------- final refresh - no flickering
			pbox.Invalidate();
		}

        public static void FillPictureBox_Horizontal(PictureBox pbox, double value, Color c1, Color c2, double MarkPoint)
		{
			// ------------------------------------------------------- using a bitmap for best performance
			if (pbox.Image == null) 
            {
                Module_ImageFilters.InitPictureboxImage(pbox);
			}
			// -------------------------------------------------------
			if (double.IsNaN(value)) value = 0; 
			if (value < 0) value = 0; 
			if (value > 1) value = 1;
            Int32 v = (int)(value * pbox.ClientSize.Width);
			// ------------------------------------------------------- using "Graphics.FromImage" for best performance
            Graphics g = Graphics.FromImage(pbox.Image);

            g.FillRectangle(new SolidBrush(c1), 0, 0, v, pbox.ClientSize.Height);
            g.FillRectangle(new SolidBrush(c2), v, 0, pbox.ClientSize.Width - v, pbox.ClientSize.Height);
			//
			// ------------------------------------------------------- final refresh - no flickering
            pbox.Refresh();
		}

	}
}
